Index: src/UIElements/Menu/TextMenu/TextMenu.hpp
===================================================================
--- src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision b59da6e8dbaa0c9c1ed4e190d2b7cd4ccec6152a)
+++ src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision 8f3f407211aab85d7d899e17a7d633813f02ad83)
@@ -25,4 +25,9 @@
 
 /** TextMenu is a specialization of MenuInterface to access TxMenu-like menus.
+ *
+ * Basically, this class is to be used in the MainWindow class of the TextUI.
+ * There, we simply instantiate the class and call init() in order to add all
+ * MenuItem's from MenuDescriptions and Action's ActionRegistry.
+ *
  * \sa QtMenu.
  */
@@ -31,4 +36,8 @@
 {
 public:
+  /** Constructor for class TextMenu.
+   * Initializes outputter and token and takes note whether to delete the
+   * MenuInstance or not.
+   */
   TextMenu(std::ostream &_outputter, const std::string &_token) :
     MenuInterface(_token),
@@ -46,4 +55,7 @@
   {}
 
+  /** Destructor of MenuInstance.
+   *
+   */
   virtual ~TextMenu()
   {
@@ -52,4 +64,7 @@
   }
 
+  /** Display this MenuInstance.
+   *
+   */
   void display()
   {
@@ -57,4 +72,7 @@
   }
 
+  /** Returns a pointer to the contained/wrapped MenuInstance.
+   * \return pointer to template class pointer
+   */
   T * const getMenuInstance()
   {
@@ -62,4 +80,8 @@
   }
 
+  /** Reserves a specific trigger key such that it is not used during init().
+   * \param trigger trigger key
+   * \param &name token given for reference.
+   */
   void reserveShortcut(char trigger, const std::string &name)
   {
@@ -78,4 +100,8 @@
   MenuShortcutMap ShortcutMap;
 
+  /** Adds an ActionItem by simply creating a new one.
+   * \param &token token of Action (token in ActionRegistry)
+   * \param &description descriptive text to be shown
+   */
   virtual void addActionItem(const std::string &token, const std::string &description)
   {
@@ -83,4 +109,7 @@
   }
 
+  /** Adds a (dead) separator item.
+   *
+   */
   virtual void addSeparatorItem()
   {
@@ -88,4 +117,10 @@
   }
 
+  /** Adds a Menu to this current Menu.
+   * We also create here a leave action for this submenu to be able to return
+   * to the current one again
+   * \param &token token of the menu
+   * \param &description descriptive text
+   */
   virtual void addSubmenuItem(const std::string &token, const std::string &description)
   {
@@ -102,4 +137,10 @@
   }
 
+  /** Return the next available trigger key suitable to this name.
+   * This function is used internally to make sure that each key is unique to
+   * each Action/Menu. The chosen trigger key is also stored in an internal ShortcutMap.
+   * \param &name text shown in menu
+   * \return trigger key
+   */
   char getSuitableShortForm(const std::string &name)
   {
Index: src/UIElements/Menu/TextMenu/TxMenu.cpp
===================================================================
--- src/UIElements/Menu/TextMenu/TxMenu.cpp	(revision b59da6e8dbaa0c9c1ed4e190d2b7cd4ccec6152a)
+++ src/UIElements/Menu/TextMenu/TxMenu.cpp	(revision 8f3f407211aab85d7d899e17a7d633813f02ad83)
@@ -31,7 +31,12 @@
 
 
-/**
+/** Constructor for class TxMenu.
+ *
  * produce a text menu with a given title.
  * The text will later be displayed using the stream passed to the constructor.
+ * \param &_outputter output stream to use for displaying the text
+ * \param _title title of this menu
+ * \param _spacer key to separate trigger key from descriptive text shown
+ * \param _length maximum length of the descriptive text
  */
 TxMenu::TxMenu(std::ostream& _outputter, const std::string _title, char _spacer,int _length) :
@@ -45,4 +50,7 @@
 }
 
+/** Destructor for class TxMenu.
+ *
+ */
 TxMenu::~TxMenu()
 {
@@ -51,20 +59,34 @@
 }
 
+/** Adds an MenuItem to the internal list.
+ * \param *item item to add
+ */
 void TxMenu::addItem(MenuItem* item) {
   items.push_back(item);
 }
 
+/** Removes an MenuItem to the internal list.
+ * \param *item item to remove
+ */
 void TxMenu::removeItem(MenuItem* item) {
   items.remove(item);
 }
 
+/** Function to quit this TxMenu.
+ */
 void TxMenu::doQuit(){
   quit = true;
 }
 
+/** Return the current state of quitting.
+ * \return quit boolean
+ */
 bool TxMenu::hasQuit(){
   return quit;
 }
 
+/** Display in a formatted manner a given entry of this menu.
+ * \param *entry MenuItem to show
+ */
 void TxMenu::showEntry(MenuItem* entry){
   if(entry->isActive()==false){
@@ -78,4 +100,7 @@
 }
 
+/** Display this menu.
+ *
+ */
 void TxMenu::display() {
   char choice;
@@ -114,8 +139,14 @@
 }
 
+/**  Return the internally stored title of the menu.
+ * \return title string
+ */
 std::string TxMenu::getTitle(){
   return title;
 }
 
+/**  Return the internally stored outputter of the menu.
+ * \return output stream reference
+ */
 std::ostream& TxMenu::getOutputter()
 {
@@ -123,5 +154,7 @@
 }
 
-
+/** Add a default item to the menu.
+ * \param *_defaultItem MenuItem to act as default item.
+ */
 void TxMenu::addDefault(MenuItem* _defaultItem) {
   defaultItem = _defaultItem;
@@ -130,4 +163,8 @@
 /****************************** Contained Actions ****************/
 
+/** Constructor for class TxMenu::LeaveAction.
+ * \param _menu pointer to the containing TxMenu
+ * \param &LeaveActionTrait ActionTraits for this Action
+ */
 TxMenu::LeaveAction::LeaveAction(TxMenu* const _menu, const ActionTraits & LeaveActionTrait) :
   Action(LeaveActionTrait, true),
@@ -135,17 +172,32 @@
 {}
 
+/** Destructor for class TxMenu::LeaveAction.
+ *
+ */
 TxMenu::LeaveAction::~LeaveAction(){}
 
+/** We can't undo the leave action.
+ * \return false
+ */
 bool TxMenu::LeaveAction::canUndo(){
   return false;
 }
 
+/** We should never undo the leave action.
+ * \return false
+ */
 bool TxMenu::LeaveAction::shouldUndo(){
   return false;
 }
 
+/** Internal function to obtain parameters from a storage.
+ * We do not use this one as we don't need any parameters.
+ */
 void TxMenu::LeaveAction::getParametersfromValueStorage()
 {}
 
+/** Internal function to construct the dialog.
+ * We do not need this function as there is no dialog to construct.
+ */
 Dialog* TxMenu::LeaveAction::fillDialog(Dialog *dialog){
   ASSERT(dialog,"No Dialog given when filling action dialog");
@@ -153,5 +205,7 @@
 }
 
-
+/** Calls TxMenu::doQuit() on the stored menu reference.
+ * \return ActionState pointer with success
+ */
 Action::state_ptr TxMenu::LeaveAction::performCall(){
   menu->doQuit();
@@ -159,12 +213,19 @@
 }
 
-
+/** Implementation of undo function for an Action.
+ * We do not use this functionality.
+ * \return ActionState pointer with failure
+ */
 Action::state_ptr TxMenu::LeaveAction::performUndo(Action::state_ptr){
   ASSERT(0,"Cannot undo leaving a menu");
-  return Action::success;
-}
-
+  return Action::failure;
+}
+
+/** Implementation of redo function for an Action.
+ * We do not use this functionality.
+ * \return ActionState pointer with failure
+ */
 Action::state_ptr TxMenu::LeaveAction::performRedo(Action::state_ptr){
   ASSERT(0,"Cannot redo leaving a menu");
-  return Action::success;
-}
+  return Action::failure;
+}
Index: src/UIElements/Menu/TextMenu/TxMenu.hpp
===================================================================
--- src/UIElements/Menu/TextMenu/TxMenu.hpp	(revision b59da6e8dbaa0c9c1ed4e190d2b7cd4ccec6152a)
+++ src/UIElements/Menu/TextMenu/TxMenu.hpp	(revision 8f3f407211aab85d7d899e17a7d633813f02ad83)
@@ -20,12 +20,27 @@
 class MenuItem;
 
-/**
- * Used to produce any kind of text menu
+/** Menu for the TextUI.
  *
- * All Items are displayed and user is prompted for a key. The item corresponding to that key is then activated.
+ * Used to produce any kind of text menu. This is a generic text menu user
+ * interface, i.e. we have a list of MenuItem's, which can either be
+ * -# Action's
+ * -# Displayers
+ * -# Separators
+ * -# other Menu's
+ *
+ * In this manner we have a tree structure, the (sub)menus generating new
+ * branches, the rest making up the leaves.
+ *
+ * All Items are displayed via a given output stream and user is prompted
+ * for a key. The item corresponding to that key is then activated.
  */
 class TxMenu
 {
 public:
+  /** This specific action is used to leave a submenu and return to an upper one.
+   * It differs from other Action's (and thus cannot be put into the usual
+   * structure) that we have to store the reference to the menu it belongs to.
+   * There, we call the doQuit() member function on performCall().
+   */
   class LeaveAction : public Action {
   public:
